## golang-weekly 2012.03.04

=== doc/Makefile ===
# Copyright 2009 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

HTML=\
	articles/defer_panic_recover.html\
	articles/error_handling.html\
	articles/slices_usage_and_internals.html\
	articles/laws_of_reflection.html\
	effective_go.html\
	go1.html\

all: tmpltohtml $(HTML)

tmpltohtml: tmpltohtml.go
	go build tmpltohtml.go

%.html: %.tmpl tmpltohtml
	./makehtml $*.tmpl

=== src/cmd/gc/Makefile ===
# Copyright 2012 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

include ../../Make.dist

install: y.tab.h builtin.c

y.tab.h: go.y
	bison -v -y -d go.y
	# make yystate global, yytname mutable
	cat y.tab.c | sed '/ int yystate;/d; s/int yychar;/int yychar, yystate;/; s/static const char \*const yytname/const char *yytname/; s/char const \*yymsgp/char *yymsgp/' >y1.tab.c
	mv y1.tab.c y.tab.c
	awk -f bisonerrors y.output go.errors >yerr.h

builtin.c: runtime.go unsafe.go
	./mkbuiltin

=== test/bench/go1/Makefile ===
include $(GOROOT)/src/Make.inc

TARG=go1
GOFILES=\
	dummy.go\

include $(GOROOT)/src/Make.pkg

test:
	echo go1: tests disabled for now TODO

=== src/pkg/exp/norm/Makefile ===
# Copyright 2011 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

maketables: maketables.go triegen.go
	go build $^

maketesttables: maketesttables.go triegen.go
	go build $^

normregtest: normregtest.go
	go build $^

tables:	maketables
	./maketables > tables.go
	gofmt -w tables.go

trietesttables: maketesttables
	./maketesttables > triedata_test.go
	gofmt -w triedata_test.go

# Downloads from www.unicode.org, so not part
# of standard test scripts.
test: testtables regtest

testtables: maketables
	./maketables -test -tables=

regtest: normregtest
	./normregtest

=== src/pkg/go/build/Makefile ===
# Copyright 2009 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

syslist.go: ../../../Make.inc Makefile
	echo '// Generated automatically by make.' >$@
	echo >>$@
	echo 'package build' >>$@
	echo >>$@
	echo 'const goosList = "$(GOOS_LIST)"' >>$@
	echo 'const goarchList = "$(GOARCH_LIST)"' >>$@

=== debian/changelog ===
golang-weekly (2012.03.04-1) unstable; urgency=low

  * Imported Upstream version 2012.03.04

 -- Ondřej Surý <ondrej@debian.org>  Fri, 09 Mar 2012 08:20:00 +0100

golang-weekly (2012.02.22-4) unstable; urgency=low

  * Preserve timestamps on source files (Closes: #658421)

 -- Ondřej Surý <ondrej@debian.org>  Sat, 03 Mar 2012 20:37:23 +0100

golang-weekly (2012.02.22-3) unstable; urgency=low

  * Conflict with golang-tools (Closes: #661726)
  * Bump standards to 3.9.3

 -- Ondřej Surý <ondrej@debian.org>  Wed, 29 Feb 2012 20:44:46 +0100

golang-weekly (2012.02.22-2) unstable; urgency=low

  * Check for defined(__FreeBSD_kernel__) as well
  * Add more kFreeBSD patches (Missing symbols SIGFILLSET and AI_MASK)

 -- Ondřej Surý <ondrej@debian.org>  Wed, 29 Feb 2012 16:12:23 +0100

golang-weekly (2012.02.22-1) unstable; urgency=low

  * Imported Upstream version 2012.02.22
  * Add custom version of version.sh
  * Update IPv6 patch to new release
  * Remove patches obsoleted by new build system (this will need more
    checking if everything works as expected)
  * Update lintian-overrides

 -- Ondřej Surý <ondrej@debian.org>  Wed, 29 Feb 2012 11:30:52 +0100

=== debian/control ===
Source: golang-weekly
Section: devel
Priority: optional
Maintainer: Ondřej Surý <ondrej@debian.org>
Vcs-Browser: http://git.debian.org/?p=pkg-google/golang.git
Vcs-Git: git://git.debian.org/pkg-google/golang.git
Build-Depends: debhelper (>= 7.4.10), bison, ed, mawk | awk, perl
Build-Depends-Indep: po-debconf
Standards-Version: 3.9.3
Homepage: http://golang.org/

Package: golang-weekly-go
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Replaces: golang-weekly-tools
Conflicts: golang-go, golang-weekly-tools, golang-tools
Provides: go-compiler, golang-go, golang-weekly-tools
Description: Experimental Go programming language compiler
 This package provides assembler, compiler and linker for the Go
 programming language.  This is Google's Go implementation of the
 tool chain.
 .
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient.  Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection.  It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 Go is an experiment. We hope adventurous users will give it a try and
 see if they enjoy it. Not every programmer will, but we hope enough
 will find satisfaction in the approach it offers to justify further
 development. The language can (and still does) change between weekly
 releases, check http://golang.org/doc/devel/weekly.html before
 upgrading this package.

Package: golang-weekly-src
Conflicts: golang-src
Provides: golang-src
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, golang-weekly-go
Description: Go programming language compiler (.go source files)
 This package provides the source files for the Go programming
 language needed for godoc and goinstall.
 .
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient.  Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection.  It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 Go is an experiment. We hope adventurous users will give it a try and
 see if they enjoy it. Not every programmer will, but we hope enough
 will find satisfaction in the approach it offers to justify further
 development. The language can (and still does) change between weekly
 releases, check http://golang.org/doc/devel/weekly.html before
 upgrading this package.

Package: golang-weekly-doc
Conflicts: golang-doc
Provides: golang-doc
Architecture: all
Depends: ${misc:Depends}, golang-weekly-go
Section: doc
Description: Documentation for Google's Go programming language
 This package provides the documentation for the Go programming
 language.
 .
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient.  Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection.  It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 You can view a nicely formatted documentation by running godoc
 --http=:6060 and then visiting http://localhost:6060/doc/install.html.
 .
 Go is an experiment. We hope adventurous users will give it a try and
 see if they enjoy it. Not every programmer will, but we hope enough
 will find satisfaction in the approach it offers to justify further
 development. The language can (and still does) change between weekly
 releases, check http://golang.org/doc/devel/weekly.html before
 upgrading this package.

Package: golang-weekly-dbg
Conflicts: golang-dbg
Provides: golang-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 armel armhf
Depends: ${misc:Depends}, golang-weekly-go (= ${binary:Version})
Recommends: gdb
Section: debug
Priority: extra
Description: Go programming language tool chain [debug]
 This package provides the debug symbols for Google's Go tool
 chain binaries (assembler, compiler, linker) needed for properly
 debugging errors in the tool chain with gdb.
 .
 This package uses the weekly snapshot releases, for more information see:
 http://golang.org/doc/devel/weekly.html

Package: golang-weekly
Depends: ${misc:Depends},
	 golang-weekly-go (>= ${source:Version}),
	 golang-weekly-src (>= ${source:Version}),
	 golang-weekly-doc (>= ${source:Version})
Architecture: all
Description: Experimental Go programming language [meta package]
 This package is a metapackage that, when installed, guarantees
 that (almost) full Go development environment is installed.
 .
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient.  Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection.  It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 Go is an experiment. We hope adventurous users will give it a try and
 see if they enjoy it. Not every programmer will, but we hope enough
 will find satisfaction in the approach it offers to justify further
 development. The language can (and still does) change between weekly
 releases, check http://golang.org/doc/devel/weekly.html before
 upgrading this package.

=== debian/rules ===
#!/usr/bin/make -f
# This file is in the public domain.
# You may freely use, modify, distribute, and relicense it.

PACKAGE = golang-weekly

libexecdir := /usr/lib/go
datadir := /usr/share/go
bindir := /bin

build clean install binary-arch binary-indep binary:
	+dh --parallel $(opt_no_act) $@

override_dh_auto_clean:
	rm -rf bin
	rm -f debian/*+
	rm -f debian/build.stamp
	: NEEDSWORK: update src/pkg/Makefile.
	#cd src/pkg && $(GOBIN)/gomake exp/ogle.clean
	rm -f src/pkg/Make.deps
	rm -f test/pass.out test/run.out test/times.out

override_dh_auto_build: debian/build.stamp

override_dh_auto_test:
	:
#	$(no_check) || { cd src && bash ./run.bash --no-rebuild; }

override_dh_compress:
	dh_compress -Xusr/share/doc/$(PACKAGE)-doc/html -Xusr/share/doc/$(PACKAGE)-doc/godoc

override_dh_install:
	dh_install --fail-missing
	for f in $$(find src/cmd -name doc.go ; find src/pkg -name \*.go); do \
	  install -p -D -m 0644 $$f debian/$(PACKAGE)-src/$(datadir)/$$f; \
	done

override_dh_strip:
	dh_strip -X".a" -Xgoinstall -Xgodoc -Xgoyacc -Xbin/cgo -Xebnflint -Xgofix -Xgofmt -Xgovet -Xgotest --dbg-package=$(PACKAGE)-dbg

debian/build.stamp:
	rm -f debian/build.stamp
	mkdir -p $(GOBIN)
	+cd src && bash ./make.bash
	>debian/build.stamp

opt_no_act =
no_check = ! :

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    $(warning no support for disabling optimization)
endif

ifneq (,$(findstring n,$(MAKEFLAGS)))
    opt_no_act = --no-act
endif

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
    no_check = :
endif

GOROOT := $(CURDIR)
GOROOT_FINAL := $(libexecdir)
GOBIN := $(CURDIR)$(bindir)
GOARM :=

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null)
DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
DEB_BUILD_ARCH_OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS 2>/dev/null)
DEB_BUILD_ARCH_CPU := $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU 2>/dev/null)

ifeq ($(DEB_BUILD_ARCH_OS), kfreebsd)
    GOHOSTOS := freebsd
else ifeq ($(DEB_BUILD_ARCH_OS), linux)
    GOHOSTOS := linux
else
    $(error unrecongized build host kernel $(DEB_BUILD_ARCH_OS)!)
endif

ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
    GOOS := freebsd
else ifeq ($(DEB_HOST_ARCH_OS), linux)
    GOOS := linux
else
    $(error unrecognized kernel $(DEB_HOST_ARCH_OS)!)
endif

ifeq ($(DEB_BUILD_ARCH_CPU), i386)
    GOHOSTARCH := 386
else ifeq ($(DEB_BUILD_ARCH_CPU), amd64)
    GOHOSTARCH := amd64
else ifeq ($(DEB_BUILD_ARCH_CPU), arm)
    GOHOSTARCH := arm
else ifeq ($(DEB_BUILD_ARCH_CPU), armhf)
    GOHOSTARCH := arm
else
    $(error unrecognized build host instruction set $(DEB_HOST_ARCH_CPU)!)
endif

ifeq ($(DEB_HOST_ARCH_CPU), i386)
    GOARCH := 386
    GOPREFIX := 8
else ifeq ($(DEB_HOST_ARCH_CPU), amd64)
    GOARCH := amd64
    GOPREFIX := 6
else ifeq ($(DEB_HOST_ARCH_CPU), arm)
    GOARCH := arm
    GOPREFIX := 5
ifeq ($(DEB_HOST_ARCH), armel)
    GOARM := 5
else ifeq ($(DEB_HOST_ARCH), armhf)
    GOARM := 6
else
    $(error unrecognized arm architecture $(DEB_HOST_ARCH)!)
endif
else
    $(error unrecognized instruction set $(DEB_HOST_ARCH_CPU)!)
endif

export GOROOT GOROOT_FINAL GOOS GOARCH GOARM GOBIN GOHOSTARCH GOHOSTOS

REPO = https://go.googlecode.com/hg/
GOLANG_ORIG_DIR = $(CURDIR)/../go-weekly
get-orig-source:
	-set -e; \
	if [ ! -d $(GOLANG_ORIG_DIR) ]; then \
		hg clone -r"weekly" "$(REPO)" "$(GOLANG_ORIG_DIR)"; \
	fi
	cd "$(GOLANG_ORIG_DIR)"; \
	hg pull; \
	hg update "weekly"; \
	VERSION=$$(hg identify -t -r"weekly" | perl -e '<> =~ /weekly\.(\d+)-(\d+)-(\d+)([\.\d]*)/; print "$$1.$$2.$$3$$4"'); \
	rm -rf "$(CURDIR)/../$(PACKAGE)-$$VERSION/"; \
	hg archive -tfiles -r"weekly" -X'.hg*' -X'doc/talks/go_talk-20091030.pdf' "$(CURDIR)/../$(PACKAGE)-$$VERSION/"; \
	$(CURDIR)/debian/version.sh "weekly"; \
	cp VERSION "$(CURDIR)/../$(PACKAGE)-$$VERSION/"; \
	cd ..; \
	tar -czf "$(CURDIR)/../$(PACKAGE)_$$VERSION.orig.tar.gz" "$(PACKAGE)-$$VERSION/"; \
	rm -rf "$(CURDIR)/../$(PACKAGE)-$$VERSION/"; \
	echo "Now run git-import-orig $(CURDIR)/../$(PACKAGE)_$$VERSION.orig.tar.gz"

.PHONY: build clean install binary-arch binary-indep binary
